module.exports = {
    env: {
        browser: true,
        node: true,
        es6: true,
        commonjs: true
    },

    rules: {
        // Possible Errors
        'getter-return': 2,
        'for-direction': 0,
        'now-await-in-loop': 0,
        'no-compare-neg-zero': 2,
        'no-cond-assign': 2,
        'no-console': 0,
        'no-constant-condition': 0,
        'no-control-regex': 2,
        'no-debugger': 2,
        'no-dupe-args': 2,
        'no-dupe-keys': 2,
        'no-duplicate-case': 2,
        'no-empty': 2,
        'no-empty-character-class': 2,
        'no-ex-assign': 2,
        'no-extra-boolean-cast': 2,
        'no-extra-parens': 0,
        'no-extra-semi': 0,
        'no-func-assign': 2,
        'no-inner-declarations': [2, 'functions'],
        'no-invalid-regexp': [2, { 'allowConstructorFlags': ['u', 'y'] }],
        'no-irregular-whitespace': 2,
        'no-obj-calls': 2,
        'no-regex-spaces': 2,
        'no-sparse-arrays': 2,
        'no-unexpected-multiline': 2,
        'no-unreachable': 2,
        'no-unsafe-negation': 2,
        'use-isnan': 2,
        'valid-typeof': 2,

        // Best Practices
        'accessor-pairs': 2,
        'curly': [2, 'multi-line'],
        'dot-location': [2, 'property'],
        'eqeqeq': [2, 'always', { 'null': 'ignore' }],
        'no-caller': 2,
        'no-empty-function': 2,
        'no-empty-pattern': 2,
        'no-eval': 2,
        'no-extend-native': 2,
        'no-extra-bind': 2,
        'no-fallthrough': 2,
        'no-floating-decimal': 2,
        'no-global-assign': 1,
        'no-implied-eval': 2,
        'no-lone-blocks': 2,
        'no-magic-numbers': [1, { "ignoreArrayIndexes": true }],
        'no-multi-spaces': 1,
        'no-new': 2,
        'no-new-func': 2,
        'no-new-wrappers': 2,
        'no-octal': 2,
        'no-octal-escape': 2,
        'no-param-reassign': 0,
        'no-redeclare': 2,
        'no-return-assign': 2,
        'no-self-assign': 2,
        'no-self-compare': 2,
        'no-sequences': 2,
        'no-throw-literal': 2,
        'no-unused-expressions': 0,
        'no-unused-labels': 0,
        'no-useless-call': 0,
        'no-useless-concat': 2,
        'no-useless-escape': 2,
        'no-useless-return': 0,
        'no-void': 0,
        'no-warning-comments': 0,
        'no-with': 2,
        'prefer-promise-reject-errors': 0,
        'radix': 2,
        'require-await': 0,
        'vars-on-top': 0,
        'wrap-iife': [2, 'any'],
        'yoda': 0,

        // Strict Mode
        'strict': 0,

        // Variables
        'init-declarations': 0,
        'no-catch-shadow': 0,
        'no-delete-var': 2,
        'no-label-var': 2,
        'no-restricted-globals': 0,
        'no-shadow': 0,
        'no-shadow-restricted-names': 2,
        'no-undef': 2,
        'no-undef-init': 2,
        'no-undefined': 0,
        'no-unused-vars': [1, { "args": "none" }],
        'no-use-before-define': 0,

        // Node.js and CommonJS

        // Stylistic Issues
        'array-bracket-newline': 0,
        'array-bracket-spacing': 0,
        'array-element-newline': 0,
        'block-spacing': [2, 'always'],
        'brace-style': [2, '1tbs', { 'allowSingleLine': true }],
        'camelcase': 0,
        'comma-dangle': 2,
        'comma-spacing': 2,
        'comma-style': [2, 'last'],
        'computed-property-spacing': 0,
        'consistent-this': 0,
        'eol-last': 2,
        'func-call-spacing': 0,
        'func-name-matching': 0,
        'func-names': 0,
        'func-style': 0,
        'indent': [2, 4, { 'SwitchCase': 1 }],
        'jsx-quotes': 0,
        'key-spacing': [2, { 'beforeColon': false, 'afterColon': true }],
        'keyword-spacing': 2,
        'line-comment-position': 2,
        'linebreak-style': 0,
        'lines-around-comment': 0,
        'max-depth': 0,
        'max-len': 0,
        'max-lines': 0,
        'max-nested-callbacks': 0,
        'max-params': 0,
        'max-statements': 0,
        'max-statements-per-line': 0,
        'multiline-ternary': 0,
        'new-cap': [2, { 'newIsCap': true, 'capIsNew': false }],
        'new-parens': 2,
        'newline-per-chained-call': 0,
        'no-array-constructor': 2,
        'no-bitwise': 0,
        'no-continue': 0,
        'no-inline-comments': 0,
        'no-lonely-if': 0,
        'no-mixed-operators': 0,
        'no-mixed-spaces-and-tabs': 2,
        'no-multi-assign': 2,
        'no-multiple-empty-lines': 2,
        'no-negated-condition': 0,
        'no-nested-ternary': 0,
        'no-new-object': 2,
        'no-plusplus': 0,
        'no-restricted-syntax': 0,
        'no-tabs': 0,
        'no-ternary': 0,
        'no-trailing-spaces': 2,
        'no-underscore-dangle': 0,
        'no-unneeded-ternary': 2,
        'no-whitespace-before-property': 2,
        'nonblock-statement-body-position': 0,
        'object-curly-newline': 0,
        'object-curly-spacing': 0,
        'object-property-newline': 0,
        'one-var': [2, 'never'],
        'one-var-declaration-per-line': 0,
        'operator-assignment': 0,
        'operator-linebreak': [2, 'after', { 'overrides': { '?': 'before', ':': 'before' } }],
        'padded-blocks': 0,
        'padding-line-between-statements': 0,
        'quote-props': 0,
        'quotes': [2, 'single', 'avoid-escape'],
        'require-jsdoc': 0,
        'semi': [2, 'always'],
        'semi-spacing': 0,
        'semi-style': 0,
        'sort-keys': 0,
        'sort-vars': 0,
        'space-before-blocks': [2, 'always'],
        'space-before-function-paren': [2, 'never'],
        'space-in-parens': [2, 'never'],
        'space-infix-ops': 2,
        'space-unary-ops': [2, { 'words': true, 'nonwords': false }],
        'spaced-comment': [2, 'always'],
        'switch-colon-spacing': 2,
        'template-tag-spacing': 0,
        'unicode-bom': 0,
        'wrap-regex': 0,

        // ECMAScript 6
        'arrow-body-style': 0,
        'arrow-parens': 0,
        'arrow-spacing': [2, { "before": true, "after": true }],
        'constructor-super': 2,
        'generator-star-spacing': [2, { 'before': true, 'after': false }],
        'no-class-assign': 2,
        'no-confusing-arrow': 0,
        'no-const-assign': 0,
        'no-dupe-class-members': 2,
        'no-duplicate-imports': 2,
        'no-new-symbol': 2,
        'no-restricted-imports': 0,
        'no-this-before-super': 2,
        'no-useless-computed-key': 2,
        'no-useless-constructor': 2,
        'no-useless-rename': 0,
        'no-var': 0,
        'object-shorthand': 0,
        'prefer-arrow-callback': 0,
        'prefer-const': 0,
        'prefer-destructuring': 0,
        'prefer-numeric-literals': 0,
        'prefer-rest-params': 0,
        'prefer-spread': 0,
        'prefer-template': 0,
        'require-yield': 0,
        'rest-spread-spacing': 0,
        'sort-imports': 0,
        'symbol-description': 0,
        'template-curly-spacing': 0,
        'yield-star-spacing': [2, { 'before': true, 'after': false }]
    }
}